/* 
   minetd
   mini inet daemon
   (c) 2000 R0B0
*/


#include <stdlib.h>
#include <netinet/in.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>

int main(int argc, char *argv[]) {
	struct sockaddr_in srv, rem;
	int sockfd,remfd,sa_l,ret,port;
	char *p;

	if(argc<3) {
		fprintf(stderr,"usage: %s <port> <progpath> [<progargs> ...]\n", argv[0]);
		exit(1);
	}
	port=atoi(argv[1]);
	argv+=2;
	p=argv[0];
	signal(SIGCHLD,SIG_IGN);
	sa_l=sizeof(struct sockaddr_in);
	bzero((char *)&srv,sa_l);
	srv.sin_family=AF_INET;
	srv.sin_port=htons(port);
	sockfd=socket(AF_INET,SOCK_STREAM,0);
	ret=bind(sockfd,(struct sockaddr *)&srv,sa_l);
	if(ret<0) {
		perror("bind");
		exit(-1);
	}
	listen(sockfd,5);
	while(1) {
		remfd=accept(sockfd,(struct sockaddr *)&rem,&sa_l);
		if(remfd<0) {
			perror("accept");
			exit(-1);
		}
		switch(fork()) {
			case 0:
				close(0);dup(remfd);
				close(1);dup(remfd);
				close(2);dup(remfd);
				execv(p,argv);
				perror("exec");
				exit(-1);
			default:
				close(remfd);
		}
	}
}

